/*! anamo/bootstrap-for-market-website v0.0.0 | © 2006-present Panagiotis Tsimpoglou. All rights reserved | bitbucket.org/anamo/bootstrap-for-market-website */

import $ from 'jquery'
import {
	debounce
} from '@anamo/bootstrap-for-market-website/js/helpers'

$.fn.autocomplete = function(options) {

	return this.each((i, el) => {
		let $this = $(el),
			settings = {}

		for(var key in $this.data()) {
			if($this.data().hasOwnProperty(key) && 'autocomplete' === key.substr(0, 12)) {
				settings[key.substr(12, 1).toLowerCase() + key.substr(13)] = $this.data()[key];
			}
		}

		settings = $.extend(options, settings)


		$this.on('input', debounce((e) => {
			if($(e.currentTarget).data('xhr')) {
				$(e.currentTarget).data('xhr').abort()
			}
			$(e.currentTarget).data('xhr',
				$.post(options.url, options.data.call(e.currentTarget), null, 'json')

				.done((r) => {
					options.done.call(e.currentTarget, r)
				})

				.fail((jqXHR, textStatus, errorThrown) => {
					if('abort' === errorThrown) {
						return;
					}
					options.fail.call(e.currentTarget)
				})

				.always(() => {
					options.always.call(e.currentTarget)
				})
			)
		}, 190))

	})

}

/**
 * One autocomplete open per page (restriction of focusout event of popover, needs to be linked to the trigger to access the initiating element)
 *
 * <input type="text" data-toggle="autocomplete" data-selector=".search-popover">
 * <input type="text" data-container=".search-area" data-toggle="autocomplete" data-selector=".search-popover">
 *
 * <div class="popover autocomplete-popup search-popover"></div>
 */


$(document).

on('focus blur', '[data-toggle="autocomplete"]', (e) => {
	clearTimeout($($(e.currentTarget).data('selector')).data('bs-autocomplete'))
}).

on('focus', '[data-toggle="autocomplete"]', (e) => {
	$($(e.currentTarget).data('container') || $(e.currentTarget)).addClass('autocomplete')
}).

on('blur', '[data-toggle="autocomplete"]', (e) => {
	$($(e.currentTarget).data('selector')).data('bs-autocomplete', setTimeout(() => {
		$($(e.currentTarget).data('container') || $(e.currentTarget)).removeClass('autocomplete')
	}, 300))
}).

on('keydown', '[data-toggle="autocomplete"]', (e) => {
	if(e.keyCode === 27) {
		clearTimeout($($(e.currentTarget).data('selector')).data('bs-autocomplete'))
		$($(e.currentTarget).data('container') || $(e.currentTarget)).removeClass('autocomplete')
	} else {
		$(e.currentTarget).trigger('focus')
	}
}).

on('click focusin focusout', '.autocomplete-popup', (e) => {
	clearTimeout($(e.currentTarget).data('bs-autocomplete'))
}).

on('focusout', '.autocomplete-popup', (e) => {
	$(e.currentTarget).data('bs-autocomplete', setTimeout(() => {
		$('.autocomplete').removeClass('autocomplete')
	}, 300))
}).

on('click', (e) => {
	$('.autocomplete [data-toggle="autocomplete"]').each((index, item) => {
		if($(e.target).closest(item).length === 0 && $(e.target).closest($($(item).data('selector'))).length === 0) {
			clearTimeout($(item).data('bs-autocomplete'))
			$('.autocomplete').removeClass('autocomplete')
		}
	})
})
